#!/usr/bin/perl -w
#
# Quick and dirty slide show motor for using with ``screen'' utility
# based on static text file

my $program="./programme.txt";

use strict;
use IO::Socket::UNIX;

my $uuid=join("",map { ("a".."z","-","0".."9","_","A".."Z")[rand(64)]} (0..9) );
my $sockname="/tmp/cgisock-".$uuid.".".$$;
my $sk=new IO::Socket::UNIX(-Listen=>1,Local=>$sockname) or die;
$sk->bind($sockname);$sk->listen();

printf "perl -MIO::Socket -e 'my \$s=new IO::Socket::UNIX(\"%s\");print \$s \$ARGV[0]'\n",$sockname;

print `tput civis`;
$SIG{INT} = sub { print `tput cnorm`; exit };
open my $fh, "<".$program or die;
my ( $t1, $t2, $t3, $t4, @slides );
while (<$fh>) {
    chomp;
    /^\S/     && do { $t1 = $_; next };
    /^\s{4}-/ && do { $t3 = $_; next };
    /^\s{2}-/ && do { $t2 = $_; next };
    /^\s+\+/
      && do { push @slides, sprintf "\ek%s\e\\\n%s\n%s\n%s\r", $_,$t1, $t2, $t3 };
}
close $fh;
my $cslide = 0;
while (1) {
    $cslide+=$1 if accept(NS,$sk) && <NS> =~ /^(-?1)$/;
    $cslide = 0        if $cslide > $#slides;
    $cslide = $#slides if $cslide < 0;
    syswrite STDOUT, $slides[$cslide];
};
