# 
# Bash source file for fine elapsed time reporting
# based on /proc/uptime, display elapsed time in 1/100 sec.
#
# (C) 2011-2012 Felix Hauri - felix@f-hauri.ch
# Licensed under terms of LGPL v3. www.gnu.org

# after sourcing script:
# syntaxe: elap <simple text report>

elap() {
    NOW=($(</proc/uptime))
    NOW=${NOW%.*}${NOW#*.}
    ELAP=$((NOW-LAST))
    [ ${#ELAP} -lt 2 ] && ELAP=0$ELAP
    LAST=$NOW
    printf "%6d.%s %s\n" "${ELAP:0:${#ELAP}-2}" ${ELAP:${#ELAP}-2} "${*}"
}

export NOW ELAP LAST
export -f elap
