#
# Bash source file for fine elapsed time reporting
# based on /proc/timer_list, display elapsed time in nanosecs
#
# (C) 2011-2012 Felix Hauri - felix@f-hauri.ch
# Licensed under terms of LGPL v3. www.gnu.org

# after sourcing script:
# syntaxe: elap <simple text report>

elap() {
    _Z9=000000000
    NOW=$(</proc/timer_list)
    NOW=${NOW#*now at }
    NOW=${NOW%% *}
    ELAP=$((NOW-LAST))
    [ ${#ELAP} -lt 9 ] && ELAP=${_Z9:0:9-${#ELAP}}$ELAP
    LAST=$NOW
    printf "%6d.%s %s\n" "${ELAP:0:${#ELAP}-9}" ${ELAP:${#ELAP}-9} "${*}"
}
    
export NOW ELAP LAST
export -f elap
